// Place your application-specific JavaScript functions and classes here
// This file is automatically included by javascript_include_tag :defaults

////////////////////////////////////////////////////////////

NUM_PLAYERS = 4;

////////////////////////////////////////////////////////////

/*
function getElementsByAttribute(attr,val,container)
{
    container = container || document;
    var all = container.all || container.getElementsByTagName('*');
    var arr = [];
    for (var k=0; k < all.length; k++)
        if (all[k].getAttribute(attr) == val)
            arr[arr.length] = all[k];
    return arr;
}

// E.g. var helloElms = getElementsByCondition(function(el){return el.className.indexOf('hello')>-1})
function getElementsByCondition(condition,container)
{
    container = container || document;
    var all = container.all || container.getElementsByTagName('*');
    var arr = [];
    for (var k = 0; k < all.length; k++)
    {
        var elm = all[k];
        if (condition(elm,k))
            arr[arr.length] = elm;
    }
    return arr;
} 
*/

////////////////////////////////////////////////////////////

function toggleVisibility(id) {
    var vis = document.getElementById(id).style.visibility == 'hidden' ? 'visible' : 'hidden';
    document.getElementById(id).style.visibility = vis;
    return false;
}

////////////////////////////////////////////////////////////

function toggleSelectPlayer(playerIndex) {
    var h_selectedPlayer = document.getElementById("h_selected_player");
    if (!h_selectedPlayer) return;
    h_selectedPlayer.value = '';
    for (var i = 0; i < NUM_PLAYERS; ++i) {
        name = "player" + i;
        var obj = document.getElementById(name);
        var className = "player";
        if (i == playerIndex && obj.className == "player") {
            className = "player_selected";
            h_selectedPlayer.value = playerIndex+1;
        }
        obj.className = className;
    }
}

////////////////////////////////////////////////////////////

function checkSelectedPlayer() {
    var h_selectedPlayer = document.getElementById("h_selected_player");
    if (!h_selectedPlayer) return;
    var player = parseInt(h_selectedPlayer.value);
    if (""+player == "NaN") player = 0;
    var missing = false;
    if (player < 1 || player > NUM_PLAYERS)
        missing = true;
    else { // Make sure that the chosen player matches the one highlit
        var p = document.getElementById('player'+(player-1))
        if (!p || p.className != "player_selected") {
            h_selectedPlayer.value = '';
            missing = true;
        }
    }

    if (missing) {
        alert("Select a player first.");
        return false;
    }
    return true;
}

// No error checking here. If checkSelectedPlayer has already been called,
// then everything should be okay. Returns a number from 0 to the number
// of players-1.
function getSelectedPlayer() {
    return parseInt(document.getElementById("h_selected_player").value) - 1;
}

////////////////////////////////////////////////////////////

function assignChoice(choice, player) {
    var h_choice = document.getElementById("h_choice" + player);
    if (!h_choice) return false;
    h_choice.value = choice;
    return true;
}

function submitAnswerChoice(choice) {
    if (!checkSelectedPlayer()) return;
    if (!assignChoice(choice, getSelectedPlayer())) return;
    var h_form = document.getElementById("hidden_form");
    if (!h_form) return;
    h_form.submit();
}

////////////////////////////////////////////////////////////

// Assumes a valid selected player already exists.
function dailyDoubleAssignBid() {
    var player = getSelectedPlayer();
    var h_bid = document.getElementById("h_bid" + player);
    if (!h_bid) return false;

    var bid = document.getElementById("dd_bid");
    if (!bid) return false;
    var b = parseInt(bid.value)
    if (""+b == "NaN") {
        alert("Enter a valid bid amount.")
        return false;
    }
    if (b < 0) {
        alert("Enter a non-negative bid amount.")
        return false;
    }

    h_bid.value = bid.value = b;
    return true;
}

function dailyDoubleSubmitBid() {
    if (!checkSelectedPlayer()) return;
    if (!dailyDoubleAssignBid()) return;
    var h_form = document.getElementById("hidden_form");
    if (!h_form) return;
    h_form.submit();
}

////////////////////////////////////////////////////////////

function allbetAssignBid() {
    for (var player = 0; player < NUM_PLAYERS; ++player) {
        var h_bid = document.getElementById("h_bid" + player);
        if (!h_bid) return false;
        var bid = document.getElementById("all_bid" + player);
        if (!bid) return false;
        var b = parseInt(bid.value)
        if (""+b == "NaN") {
            alert("Enter a valid bid amount (received '" + bid.value + "').")
            return false;
        }
        if (b < 0) {
            alert("Enter a non-negative bid amount (received '" + bid.value + "').")
            return false;
        }

        h_bid.value = bid.value = b;
    }

    return true;
}

function allbetSubmitBid() {
    if (!allbetAssignBid()) return;
    var h_form = document.getElementById("hidden_form");
    if (!h_form) return;
    h_form.submit();
}

function assignAllChoices() {
    for (var player = 0; player < NUM_PLAYERS; ++player) {
        var   choice = document.getElementById(  "choice" + player); if (!  choice) return false;
        var h_choice = document.getElementById("h_choice" + player); if (!h_choice) return false;
        if (choice.value == '') {
            alert("Make a choice for each player.")
            return false;
        }
        h_choice.value = choice.value;
    }
    return true;
}

function allbetSubmitChoices() {
    if (!assignAllChoices()) return;
    var h_form = document.getElementById("hidden_form");
    if (!h_form) return;
    h_form.submit();
}

function finalQuestion() {
    var h_form = document.getElementById("hidden_form");
    if (!h_form) return;
    h_form.submit();
}

////////////////////////////////////////////////////////////
